﻿using System;

namespace 성적_관리_프로그램_기본_문법_활용하기_
{
    internal class App
    {
        #region 단일체
        public static App Singleton
        {
            get;//접근자
            private set;//설정자
        }
        static App()//정적 생성자- 해당 형식을 사용하기 전에 동작함을 보장
        {
            Singleton = new App();
        }

        private App()//생성자 메서드
        {
            Initialize();
        }
        
        #endregion
        #region 멤버 필드 및 속성
        int[][][] scores;
        #endregion
        #region 멤버 메서드
        private void Initialize()
        {
            Console.WriteLine("관리할 학년 수를 입력하세요.");
            int gcnt = EhFun.GetNum();
            if(gcnt == 0)
            {
                Console.WriteLine("잘못 입력하였습니다.");
                return;
            }

            scores = new int[gcnt][][];

            for(int gi = 0; gi<gcnt; gi++)
            {
                scores[gi] = InitGrade(gi + 1 );
            }
            Console.WriteLine("초기 설정을 하였습니다.");
            Console.ReadKey(true);
        }

        private int[][] InitGrade(int gn)
        {             
            Console.WriteLine("{0}학년에 반 개수를 입력하세요.", gn);
            int ccnt = EhFun.GetNum();
            if(ccnt == 0)
            {
                Console.WriteLine("잘못 입력하였습니다.");
                return null;
            }
            int[][]  gscores = new int[ccnt][];
            for (int ci = 0; ci<ccnt;ci++)
            {
                gscores[ci] = InitClass(ci + 1);
            }
            return gscores;
        }

        private int[] InitClass(int cn)
        {
            Console.WriteLine("{0}반에 학생 수를 입력하세요.", cn);
            int scnt = EhFun.GetNum();
            if (scnt == 0)
            {
                Console.WriteLine("잘못 입력하였습니다.");
                return null;
            }
            int[] cscores = new int[scnt];
            for(int i=0;i<scnt;i++)
            {
                cscores[i] = -1;
            }
            return cscores;
        }

        internal void Start()
        {
            if(scores == null)
            {
                return;
            }

            ConsoleKey key;
            while((key = SelectMenu())!=ConsoleKey.Escape)
            {
                switch(key)
                {
                    case ConsoleKey.F1: Insert(); break;
                    case ConsoleKey.F2: Delete(); break;
                    case ConsoleKey.F3: Search(); break;
                    case ConsoleKey.F4: ViewAll(); break;
                    default: Console.WriteLine("잘못 선택하였습니다."); break;
                }
                Console.WriteLine("아무 키나 누르세요.");
                Console.ReadKey(true);

            }

        }

        private void ViewAll()
        {
            for(int i = 0; i<scores.Length;i++)
            {                
                ViewGrade(i + 1, scores[i]);
            }
        }

        private void ViewGrade(int gn, int[][] gscores)
        {
            if (gscores == null)
            {
                Console.WriteLine("{0}학년에 반 정보를 잘못 입력한 상태입니다.",gn);             
                return;
            }
            Console.WriteLine("** {0} 학년 성적 정보 **", gn);
            
                for (int i = 0; i<gscores.Length;i++)
            {
                ViewClass(i + 1, gscores[i]);
            }
        }

        private void ViewClass(int cn, int[] cscores)
        {
            if (cscores == null)
            {
                Console.WriteLine("{0}반에 반 정보를 잘못 입력한 상태입니다.", cn);       
                return;
            }
            Console.WriteLine("@ {0} 반 성적 정보 ", cn);
            for (int i = 0; i < cscores.Length; i++)
            {
                if (cscores[i] != -1)
                {
                    Console.WriteLine("{0}번 :{1}", i + 1, cscores[i]);
                }
                else
                {
                    Console.WriteLine("{0}번 성적 입력하지 않음", i + 1);
                }
            }
        }

        private void Search()
        {
            Console.WriteLine("학년을 입력하세요. 1~{0}", scores.Length);
            int gn = EhFun.GetNum();
            if ((gn < 1) || (gn > scores.Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }

            Console.WriteLine("반을 입력하세요. 1~{0}", scores[gn - 1].Length);
            int cn = EhFun.GetNum();
            if ((cn < 1) || (cn > scores[gn - 1].Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }

            Console.WriteLine("번호를 입력하세요. 1~{0}", scores[gn - 1][cn - 1].Length);
            int sn = EhFun.GetNum();
            if ((sn < 1) || (sn > scores[gn - 1][cn - 1].Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }
            if(scores[gn - 1][cn - 1][sn - 1] == -1)
            {
                Console.WriteLine("성적을 입력하지 않았음...");
            }
            else
            {
                Console.WriteLine("해당 학생의 성적은 {0}입니다.", 
                    scores[gn - 1][cn - 1][sn - 1]);
            }
            
        }

        private void Delete()
        {
            Console.WriteLine("학년을 입력하세요. 1~{0}", scores.Length);
            int gn = EhFun.GetNum();
            if ((gn < 1) || (gn > scores.Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }

            Console.WriteLine("반을 입력하세요. 1~{0}", scores[gn - 1].Length);
            int cn = EhFun.GetNum();
            if ((cn < 1) || (cn > scores[gn - 1].Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }           

            Console.WriteLine("번호를 입력하세요. 1~{0}", scores[gn - 1][cn - 1].Length);
            int sn = EhFun.GetNum();
            if ((sn < 1) || (sn > scores[gn - 1][cn - 1].Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }
            scores[gn - 1][cn - 1][sn - 1] = -1;
            Console.WriteLine("삭제 성공!!!");
        }

        private void Insert()
        {
            Console.WriteLine("학년을 입력하세요. 1~{0}", scores.Length);
            int gn = EhFun.GetNum();
            if((gn<1)||(gn>scores.Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }
            if(scores[gn-1] == null)
            {
                //Console.WriteLine("해당 학년에 반 정보 입력 오류로 관리할 수 없습니다.");
                //return;
                scores[gn - 1] = InitGrade(gn);
                
            }

            Console.WriteLine("반을 입력하세요. 1~{0}", scores[gn-1].Length);
            int cn = EhFun.GetNum();
            if ((cn < 1) || (cn > scores[gn-1].Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }
            if (scores[gn - 1][cn - 1] == null)
            {
                //Console.WriteLine("해당 반에 학생 수 입력 오류로 관리할 수 없습니다.");
                //return;
                scores[gn - 1][cn-1] = InitClass(cn);
            }

            Console.WriteLine("번호를 입력하세요. 1~{0}", scores[gn - 1][cn-1].Length);
            int sn = EhFun.GetNum();
            if ((sn < 1) || (sn > scores[gn - 1][cn-1].Length))
            {
                Console.WriteLine("범위를 벗어났습니다.");
                return;
            }
            Console.WriteLine("성적을 입력하세요.");
            int score = EhFun.GetNum();
            if((score<0)||(score>100))
            {
                Console.WriteLine("잘못 입력하셨습니다. ^^;;");
                scores[gn - 1][cn - 1][sn - 1] = -1;
            }
            else
            {
                scores[gn - 1][cn - 1][sn - 1] = score;
                Console.WriteLine("입력 성공!!!");
            }
        }

        private ConsoleKey SelectMenu()
        {
            Console.Clear();
            Console.WriteLine("=== 성적 관리 프로그램 ===");
            Console.WriteLine("*   F1: 성적 추가        *");
            Console.WriteLine("*   F2: 성적 삭제        *");
            Console.WriteLine("*   F3: 성적 조회        *");
            Console.WriteLine("*   F4: 전체 성적 보기   *");
            return Console.ReadKey(true).Key;
        }
        #endregion
    }
}